﻿using System.Threading.Tasks;
using HyperCube.Models;
using HyperCube;

namespace HyperCube.Pages
{
    public partial class Wallet
    {
        private AccountModel account = new();
        string myBalance = "";

        protected override async Task OnInitializedAsync()
        {
            account = await GetCurrentAcc();
            if (Blockchain.GetMain() != null)
                myBalance = await account.GetBalance();
        }

        private async Task<AccountModel> GetCurrentAcc()
        {
            AccountModel account = new();

            var authState = await AuthenticationStateProvider.GetAuthenticationStateAsync();
            var user = authState.User;

            if (user.Identity.IsAuthenticated)
            {
                var currentUser = await UserManager.GetUserAsync(user);
                var acc = AccountModel.Find(currentUser.Id);
                if (acc != null)
                    account = acc;

                account.LoadRoles();
                //account.AccRole = Role.User;
                return account;
            }

            return null;
        }

        bool admin
        {
            get { return account.Roles.Contains(Role.Admin); }
            set
            {
                if (!account.Roles.Contains(Role.Admin))
                {
                    account.AddRole(Role.Admin);
                    MySQLConnector.Instance().SQLInsert($"insert into account_roles (account_uuid, role_id) values ('{account.UUID}', {(int)Role.Admin})");
                }
                else
                {
                    account.RemoveRole(Role.Admin);
                    MySQLConnector.Instance().SQLInsert($"delete from account_roles where account_uuid = '{account.UUID}' and role_id={(int)Role.Admin}");
                }
            }
        }
        bool initiator
        {
            get { return account.Roles.Contains(Role.Initiator); }
            set
            {
                if (!account.Roles.Contains(Role.Initiator))
                {
                    account.AddRole(Role.Initiator);
                    MySQLConnector.Instance().SQLInsert($"insert into account_roles (account_uuid, role_id) values ('{account.UUID}', {(int)Role.Initiator})");
                }
                else
                {
                    account.RemoveRole(Role.Initiator);
                    MySQLConnector.Instance().SQLInsert($"delete from account_roles where account_uuid = '{account.UUID}' and role_id={(int)Role.Initiator}");
                }
            }
        }
        bool verifier
        {
            get { return account.Roles.Contains(Role.Verifier); }
            set
            {
                if (!account.Roles.Contains(Role.Verifier))
                {
                    account.AddRole(Role.Verifier);
                    MySQLConnector.Instance().SQLInsert($"insert into account_roles (account_uuid, role_id) values ('{account.UUID}', {(int)Role.Verifier})");
                }
                else
                {
                    account.RemoveRole(Role.Verifier);
                    MySQLConnector.Instance().SQLInsert($"delete from account_roles where account_uuid = '{account.UUID}' and role_id={(int)Role.Verifier}");
                }
            }
        }
        bool requester
        {
            get { return account.Roles.Contains(Role.Requester); }
            set
            {
                if (!account.Roles.Contains(Role.Requester))
                {
                    account.AddRole(Role.Requester);
                    MySQLConnector.Instance().SQLInsert($"insert into account_roles (account_uuid, role_id) values ('{account.UUID}', {(int)Role.Requester})");
                }
                else
                {
                    account.RemoveRole(Role.Requester);
                    MySQLConnector.Instance().SQLInsert($"delete from account_roles where account_uuid = '{account.UUID}' and role_id={(int)Role.Requester}");
                }
            }
        }
    }
}